%define anolis_release 6
%global soversion 3

%define srpmhash() %{lua:
local files = rpm.expand("%_specdir/openssl.spec")
for i, p in ipairs(patches) do
   files = files.." "..p
end
for i, p in ipairs(sources) do
   files = files.." "..p
end
local sha256sum = assert(io.popen("cat "..files.." 2>/dev/null | sha256sum"))
local hash = sha256sum:read("*a")
sha256sum:close()
print(string.sub(hash, 0, 16))
}

%global _performance_build 1
%define __provides_exclude_from %{_libdir}/openssl

Name:           openssl
Version:        3.0.12
Release:        %{anolis_release}%{?dist}
Epoch:          1
Summary:        Utilities from the general purpose cryptography library with TLS implementation

License:        ASL 2.0
URL:            http://www.openssl.org/
Source0:        https://www.openssl.org/source/%{name}-%{version}.tar.gz
Source2:        Makefile.certificate
Source3:        genpatches
Source4:        make-dummy-cert
Source5:        renew-dummy-cert
Source6:        configuration-switch.h
Source7:        configuration-prefix.h
Source14:	0025-for-tests.patch

Patch1: 0001-Aarch64-and-ppc64le-use-lib64.patch
Patch2: 0002-Use-more-general-default-values-in-openssl.cnf.patch
Patch3: 0003-Do-not-install-html-docs.patch
Patch4: 0004-Override-default-paths-for-the-CA-directory-tree.patch
Patch5: 0005-apps-ca-fix-md-option-help-text.patch
Patch6: 0006-Disable-signature-verification-with-totally-unsafe-h.patch
Patch7: 0007-Add-support-for-PROFILE-SYSTEM-system-default-cipher.patch
Patch8: 0008-Add-FIPS_mode-compatibility-macro.patch
# Add check to see if fips flag is enabled in kernel
Patch9: 0009-Add-Kernel-FIPS-mode-flag-support.patch
Patch10: 0010-Add-changes-to-ectest-and-eccurve.patch
Patch11: 0011-Remove-EC-curves.patch
Patch12: 0012-Disable-explicit-ec.patch
Patch13: 0013-skipped-tests-EC-curves.patch
Patch14: 0014-load-legacy-prov.patch
# Tmp: test name change
Patch15: 0015-tmp-Fix-test-names.patch
# We load FIPS provider and set FIPS properties implicitly
Patch16: 0016-Force-fips.patch
# Embed HMAC into the fips.so
Patch17: 0017-FIPS-embed-hmac.patch
# Comment out fipsinstall command-line utility
Patch18: 0018-fipsinstall_disable.patch
# Skip unavailable algorithms running `openssl speed`
Patch19: 0019-speed-skip-unavailable-dgst.patch
# Extra public/private key checks required by FIPS-140-3
Patch20: 0020-FIPS-140-3-keychecks.patch
# Minimize fips services
Patch21: 0021-FIPS-services-minimize.patch
# Execute KATS before HMAC verification
Patch22: 0022-FIPS-early-KATS.patch
# Selectively disallow SHA1 signatures
Patch23: 0023-Selectively-disallow-SHA1-signatures.patch
Patch24: 0024-FIPS-enable-pkcs12-mac.patch
Patch25: 0025-Support-different-R_BITS-lengths-for-KBKDF.patch
# Allow SHA1 in seclevel 2 if rh-allow-sha1-signatures = yes
Patch26: 0026-Allow-SHA1-in-seclevel-2-if-rh-allow-sha1-signatures.patch
# https://github.com/openssl/openssl/pull/18103
# The patch is incorporated in 3.0.3 but we provide this function since 3.0.1
# so the patch should persist
Patch27: 0027-strcasecmp.patch
Patch28: 0028-FIPS-limit-rsa-encrypt.patch
Patch29: 0029-FIPS-KAT-signature-tests.patch
Patch30: 0030-Deny-SHA-1-signature-verification-in-FIPS-provider.patch
Patch31: 0031-fips-Expose-a-FIPS-indicator.patch
Patch32: 0032-AES-GCM-performance-optimization.patch
Patch33: 0033-FIPS-Use-OAEP-in-KATs-support-fixed-OAEP-seed.patch
Patch34: 0034-FIPS-Use-digest_sign-digest_verify-in-self-test.patch
Patch35: 0035-FIPS-Use-FFDHE2048-in-self-test.patch
# Downstream only. Reseed DRBG using getrandom(GRND_RANDOM)
Patch36: 0036-FIPS-140-3-DRBG.patch
Patch37: 0037-FIPS-140-3-zeroization.patch
Patch38: 0038-Add-FIPS-indicator-parameter-to-HKDF.patch
Patch39: 0039-rand-Forbid-truncated-hashes-SHA-3-in-FIPS-prov.patch
Patch40: 0040-signature-Remove-X9.31-padding-from-FIPS-prov.patch
Patch41: 0041-kbkdf-Add-explicit-FIPS-indicator-for-key-length.patch
Patch42: 0042-hmac-Add-explicit-FIPS-indicator-for-key-length.patch
Patch43: 0043-pbkdf2-Set-minimum-password-length-of-8-bytes.patch
Patch44: 0044-FIPS-RSA-disable-shake.patch
Patch45: 0045-signature-Add-indicator-for-PSS-salt-length.patch
Patch46: 0046-signature-Clamp-PSS-salt-len-to-MD-len.patch
Patch47: 0047-FIPS-RSA-encapsulate.patch
Patch48: 0048-add-loongarch64-support-for-openssl-3.0.11.patch
Patch49: 0049-openssl-3.0-CVE-2023-5678.patch
Patch50: 0050-openssl-3.0-CVE-2023-6129.patch
Patch51: 1001-fix-CVE-2024-0727.patch
# https://github.com/openssl/openssl/commit/18c02492138d1eb8b6548cb26e7b625fb2414a2a
Patch52: 1002-fix-CVE-2023-6237.patch
# https://github.com/openssl/openssl/commit/3559e868e58005d15c6013a0c1fd832e51c73397
Patch53: 1003-fix-CVE-2024-4603.patch

BuildRequires:  gcc git coreutils perl-interpreter sed zlib-devel /usr/bin/cmp
BuildRequires:  lksctp-tools-devel
BuildRequires:  /usr/bin/rename
BuildRequires:  /usr/bin/pod2man
BuildRequires:  /usr/sbin/sysctl
BuildRequires:  perl(Test::Harness) perl(Test::More) perl(Math::BigInt)
BuildRequires:  perl(Module::Load::Conditional) perl(File::Temp)
BuildRequires:  perl(Time::HiRes) perl(IPC::Cmd) perl(Pod::Html) perl(Digest::SHA)
BuildRequires:  perl(FindBin) perl(lib) perl(File::Compare) perl(File::Copy) perl(bigint)
BuildRequires:  perl(ExtUtils::MakeMaker)
Requires:       coreutils
Requires:       %{name}-libs = %{EVR}

%description
The OpenSSL toolkit provides support for secure communications between
machines. OpenSSL includes a certificate management tool and shared
libraries which provide various cryptographic algorithms and
protocols.

%package libs
Summary:        A general purpose cryptography library with TLS implementation
Requires:       ca-certificates >= 2008-5
Requires:       crypto-policies >= %{installed_version_of crypto-policies}
Recommends:     openssl-pkcs11

%description libs
OpenSSL is a toolkit for supporting cryptography. The openssl-libs
package contains the libraries that are used by various applications which
support cryptographic algorithms and protocols.

%package devel
Summary:        Files for development of applications which will use OpenSSL
Requires:       %{name}-libs = %{EVR}

%description devel
OpenSSL is a toolkit for supporting cryptography. The openssl-devel
package contains include files needed to develop applications which
support various cryptographic algorithms and protocols.

%package perl
Summary:        Perl scripts provided with OpenSSL
Requires:       perl-interpreter
Requires:       %{name} = %{EVR}

%description perl
OpenSSL is a toolkit for supporting cryptography. The openssl-perl
package provides Perl scripts for converting certificates and keys
from other formats to the formats used by the OpenSSL toolkit.

%package doc
Summary:        Doc files for OpenSSL
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description doc
Doc files for OpenSSL

%prep
%autosetup -S git

%build
sslarch=%{_os}-%{_target_cpu}
%ifarch x86_64
sslflags=enable-ec_nistp_64_gcc_128
%endif
%ifarch aarch64
sslarch=linux-aarch64
sslflags=enable-ec_nistp_64_gcc_128
%endif
%ifarch riscv64
sslarch=linux-generic64
%endif

RPM_OPT_FLAGS="$RPM_OPT_FLAGS -Wa,--noexecstack -Wa,--generate-missing-build-notes=yes -DPURIFY $RPM_LD_FLAGS"

export HASHBANGPERL=/usr/bin/perl
%define fips %{version}-%{srpmhash}

./Configure \
        --prefix=%{_prefix} --openssldir=%{_sysconfdir}/pki/tls ${sslflags} \
        --system-ciphers-file=%{_sysconfdir}/crypto-policies/back-ends/openssl.config \
        zlib enable-camellia enable-seed enable-rfc3779 enable-sctp \
        enable-cms enable-md2 enable-rc5 enable-ktls enable-fips\
        no-mdc2 no-ec2m enable-sm2 enable-sm4 enable-buildtest-c++\
        shared  ${sslarch} $RPM_OPT_FLAGS '-DDEVRANDOM="\"/dev/urandom\"" -DREDHAT_FIPS_VERSION="\"%{fips}\""'\
	-Wl,--allow-multiple-definition

make -s %{?_smp_mflags} all

for i in libcrypto.pc libssl.pc openssl.pc ; do
  sed -i '/^Libs.private:/{s/-L[^ ]* //;s/-Wl[^ ]* //}' $i
done

%check
# Verify that what was compiled actually works.

# Hack - either enable SCTP AUTH chunks in kernel or disable sctp for check
(sysctl net.sctp.addip_enable=1 && sysctl net.sctp.auth_enable=1) || \
(echo 'Failed to enable SCTP AUTH chunks, disabling SCTP for tests...' &&
 sed '/"msan" => "default",/a\ \ "sctp" => "default",' configdata.pm > configdata.pm.new && \
 touch -r configdata.pm configdata.pm.new && \
 mv -f configdata.pm.new configdata.pm)

# We must revert patch4 before tests otherwise they will fail
patch -p1 -R < %{PATCH4}
#We must disable default provider before tests otherwise they will fail
patch -p1 < %{SOURCE14}

OPENSSL_ENABLE_MD5_VERIFY=
export OPENSSL_ENABLE_MD5_VERIFY
OPENSSL_ENABLE_SHA1_SIGNATURES=
export OPENSSL_ENABLE_SHA1_SIGNATURES
OPENSSL_SYSTEM_CIPHERS_OVERRIDE=xyz_nonexistent_file
export OPENSSL_SYSTEM_CIPHERS_OVERRIDE
#embed HMAC into fips provider for test run
LD_LIBRARY_PATH=. apps/openssl dgst -binary -sha256 -mac HMAC -macopt hexkey:f4556650ac31d35461610bac4ed81b1a181b2d8a43ea2854cbae22ca74560813 < providers/fips.so > providers/fips.so.hmac
objcopy --update-section .rodata1=providers/fips.so.hmac providers/fips.so providers/fips.so.mac
mv providers/fips.so.mac providers/fips.so
#run tests itself
make test HARNESS_JOBS=8

%install
install -d $RPM_BUILD_ROOT{%{_bindir},%{_includedir},%{_libdir},%{_mandir},%{_libdir}/openssl,%{_pkgdocdir}}
%make_install
rename so.%{soversion} so.%{version} $RPM_BUILD_ROOT%{_libdir}/*.so.%{soversion}
for lib in $RPM_BUILD_ROOT%{_libdir}/*.so.%{version} ; do
        chmod 755 ${lib}
        ln -s -f `basename ${lib}` $RPM_BUILD_ROOT%{_libdir}/`basename ${lib} .%{version}`
        ln -s -f `basename ${lib}` $RPM_BUILD_ROOT%{_libdir}/`basename ${lib} .%{version}`.%{soversion}
done

rm -f $RPM_BUILD_ROOT%{_libdir}/*.a

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/certs
install -m644 %{SOURCE2} $RPM_BUILD_ROOT%{_pkgdocdir}/Makefile.certificate
install -m755 %{SOURCE4} $RPM_BUILD_ROOT%{_bindir}/make-dummy-cert
install -m755 %{SOURCE5} $RPM_BUILD_ROOT%{_bindir}/renew-dummy-cert

mv $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/misc/*.pl $RPM_BUILD_ROOT%{_bindir}
mv $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/misc/tsget $RPM_BUILD_ROOT%{_bindir}
mv $RPM_BUILD_ROOT%{_mandir}/man5/config.5ossl $RPM_BUILD_ROOT%{_mandir}/man5/config.cnf.5

mkdir -p -m755 $RPM_BUILD_ROOT%{_sysconfdir}/pki/CA/{certs,crl,newcerts}
mkdir -m700 $RPM_BUILD_ROOT%{_sysconfdir}/pki/CA/private

touch -r %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/openssl.cnf
touch -r %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/ct_log_list.cnf

rm -f $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/{openssl.cnf.dist,ct_log_list.cnf.dist,fipsmodule.cnf}

%files
%license LICENSE.txt
%{_bindir}/make-dummy-cert
%{_bindir}/renew-dummy-cert
%{_bindir}/openssl
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_mandir}/man7/*
%{_pkgdocdir}/Makefile.certificate
%exclude %{_mandir}/man1/*.pl*
%exclude %{_mandir}/man1/tsget*

%files libs
%license LICENSE.txt
%dir %{_sysconfdir}/pki/tls
%dir %{_sysconfdir}/pki/tls/certs
%dir %{_sysconfdir}/pki/tls/misc
%dir %{_sysconfdir}/pki/tls/private
%config(noreplace) %{_sysconfdir}/pki/tls/openssl.cnf
%config(noreplace) %{_sysconfdir}/pki/tls/ct_log_list.cnf
%attr(0755,root,root) %{_libdir}/libcrypto.so.%{version}
%{_libdir}/libcrypto.so.%{soversion}
%attr(0755,root,root) %{_libdir}/libssl.so.%{version}
%{_libdir}/libssl.so.%{soversion}
%attr(0755,root,root) %{_libdir}/engines-%{soversion}
%attr(0755,root,root) %{_libdir}/ossl-modules

%files devel
%doc CHANGES.md doc/dir-locals.example.el doc/openssl-c-indent.el
%{_prefix}/include/openssl
%{_libdir}/*.so
%{_mandir}/man3/*
%{_libdir}/pkgconfig/*.pc

%files perl
%{_bindir}/c_rehash
%{_bindir}/*.pl
%{_bindir}/tsget
%{_mandir}/man1/*.pl*
%{_mandir}/man1/tsget*
%dir %{_sysconfdir}/pki/CA
%dir %{_sysconfdir}/pki/CA/private
%dir %{_sysconfdir}/pki/CA/certs
%dir %{_sysconfdir}/pki/CA/crl
%dir %{_sysconfdir}/pki/CA/newcerts

%files doc
%doc NEWS.md README.md

%changelog
* Wed Jul 10 2024 songmingliang <songmingliang@uniontech.com> - 1:3.0.12-6
- fix CVE-2024-4603

* Wed Jun 12 2024 songmingliang <songmingliang@uniontech.com> - 1:3.0.12-5
- fix CVE-2023-6237

* Wed May 29 2024 mgb01105731 <mgb01105731@alibaba-inc.com> - 1:3.0.12-4
- fix CVE-2024-0727

* Thu Jan 11 2024 mgb01105731 <mgb01105731@alibaba-inc.com> - 1:3.0.12-3
- fix CVE-2023-6129

* Tue Nov 07 2023 Funda Wang <fundawang@yeah.net> - 1:3.0.12-2
- fix CVE-2023-5678

* Wed Oct 25 2023 Funda Wang <fundawang@yeah.net> - 1:3.0.12-1
- New version 3.0.12

* Wed Oct 18 2023 Wenlong Zhang <zhangwenlong@loongson.cn>  - 1:3.0.11-2
- add loongarch64 support for openssl

* Tue Sep 19 2023 Funda Wang <fundawang@yeah.net> - 1:3.0.11-1
- New version 3.0.11

* Wed May 31 2023 Funda Wang <fundawang@yeah.net> - 1:3.0.9-1
- New version 3.0.9

* Sat May 06 2023 happy_orange <songnannan@linux.alibaba.com> - 1:3.0.7-8
- fix CVE-2023-0465 and CVE-2023-0466

* Tue Mar 28 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 1:3.0.7-7
- Del Specific Fields

* Mon Feb 27 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1:3.0.7-6
- update require version of crypto-policies

* Thu Feb 16 2023 happy_orange <songnannan@linux.alibaba.com> - 1:3.0.7-5
- Enalbe sm2 and sm4

* Thu Feb 02 2023 happy_orange <songnannan@linux.alibaba.com> - 1:3.0.7-4
- add some patches

* Fri Dec 23 2022 chen_yu_ao <m15927509890@163.com> - 1:3.0.7-3
- change patch numbers and format

* Thu Nov 03 2022 Funda Wang <fundawang@yeah.net> - 1:3.0.7-2
- Enalbe sm2 and sm4

* Thu Nov 03 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1:3.0.7-1
- update to 3.0.7

* Mon Aug 29 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1:3.0.5-1
- update to 3.0.5

* Mon Mar  21 2022 forrest_ly <flin@linux.alibaba.com> - 1:3.0.2-1
- Update to 3.0.2

* Wed Mar  16 2022 forrest_ly <flin@linux.alibaba.com> - 1:3.0.1-2
- Fix Epoch for others pkg deps

* Tue Mar  8 2022 forrest_ly <flin@linux.alibaba.com> - 3.0.1-1
- Init for Anolis OS 23 
